﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Telerik.Windows.Data;

namespace JumpListDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private void PerformTodayTomorrowNextGrouping()
        {
            this.radJumpList.ItemsSource = null;
            this.radJumpList.GroupDescriptors.Clear();
            List<MyTask> source = new List<MyTask>();

            for (int i = 0; i < 40; i++)
            {
                MyTask task = new MyTask();

                if (i < 10)
                {
                    task.DueDate = DateTime.Now;
                }
                else if (i < 20)
                {
                    task.DueDate = DateTime.Now.AddDays(1);
                }
                else
                {
                    task.DueDate = DateTime.Now.AddDays(i);
                }

                task.Name = "Task Name " + i;
                source.Add(task);
            }

            this.radJumpList.ItemsSource = source;

            GenericGroupDescriptor<MyTask, string> gd = new GenericGroupDescriptor<MyTask, string>();
            gd.KeySelector = (MyTask t) =>
            {
                if (t.DueDate.Date == DateTime.Now.Date)
                {
                    return "Today";
                }

                if ((t.DueDate.Date - DateTime.Now.Date).Days == 1)
                {
                    return "Tomorrow";
                }

                return "Next";
            };

            this.radJumpList.GroupDescriptors.Add(gd);
        }

        private void PerformGroupingWithGroupHeaderFormatting()
        {
            this.radJumpList.ItemsSource = null;
            this.radJumpList.GroupDescriptors.Clear();
            List<MyTask> source = new List<MyTask>();

            for (int i = 0; i < 40; i++)
            {
                MyTask task = new MyTask();

                if (i < 10)
                {
                    task.DueDate = DateTime.Now;
                }
                else if (i < 20)
                {
                    task.DueDate = DateTime.Now.AddDays(1);
                }
                else
                {
                    task.DueDate = DateTime.Now.AddDays(2);
                }

                task.Name = "Task Name " + i;
                source.Add(task);
            }

            this.radJumpList.ItemsSource = source;

            GenericGroupDescriptor<MyTask, DateTime> gd = new GenericGroupDescriptor<MyTask, DateTime>();

            gd.GroupFormatString = "Formatted group header: {0}";

            gd.KeySelector = (MyTask t) =>
            {
                return t.DueDate.Date;
            };

            this.radJumpList.GroupDescriptors.Add(gd);
        }

        private void btnBindTodayTomorrowNext_Click(object sender, RoutedEventArgs e)
        {
            this.PerformTodayTomorrowNextGrouping();
        }

        private void btnBindFormat_Click(object sender, RoutedEventArgs e)
        {
            this.PerformGroupingWithGroupHeaderFormatting();
        }
    }

    public class MyTask
    {
        public string Name
        {
            get;
            set;
        }

        public DateTime DueDate
        {
            get;
            set;
        }
    }
}